<?php
include "..\\cfgmgr\\db_access.php";

class transaction {

  var $transaction_table;
  var $usr_table;
  var $plan_table;
  var $myDB;
  
  function transaction() {
	$this->myDB = new db();
    $this->transaction_table = $this->myDB->get_transaction_table();
    $this->usr_table = $this->myDB->get_usr_table();
    $this->plan_table = $this->myDB->get_plan_table();
  }

  //submit form to payment gateway
  function submit_form($url, $arr_postfields, $auto = true, $button = 'Your page will be redirected after 5 seconds<br>If not, Click the button below<p><input type="submit" value="submit">' )
  {
    echo '<form name="payment" action="'.$url.'" method=post>';
    foreach ( $arr_postfields as $key => $val )
    {
      echo '<input type="hidden" name="'.$key.'" value="'.$val.'">';
    }
    echo $button;
    echo '</form>';
    if ($auto) {
      echo '<script type="text/javascript">';
      echo 'document.payment.submit()';
      echo '</script>';
    }
  }


  function postfields_urlencode($arr_postfields)
  {
    $postfields_string = null;
    foreach ($arr_postfields as $key => $val)
    {
      if ($postfields_string != null)
        $postfields_string .= "&";
      $postfields_string .= "$key=".urlencode($val);
    }

    return $postfields_string;
  }


  //postback to payment gateway
  function postback($url, $header, $postfields, $timeout)
  {
    $ch = curl_init();
    curl_setopt ($ch, CURLOPT_URL, $url);
    curl_setopt ($ch, CURLOPT_HEADER, $header);
    curl_setopt ($ch, CURLOPT_POST, 1); 
    curl_setopt ($ch, CURLOPT_POSTFIELDS, $postfields); 
    curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt ($ch, CURLOPT_FOLLOWLOCATION, 1);
    curl_setopt ($ch, CURLOPT_TIMEOUT, $timeout);
    $res = curl_exec ($ch);
    curl_close ($ch);

    return $res;
  }

  
  function update_usr_table($username, $plan_name, $quantity = 1)
  {
    if ($username == null || $username == "" || $plan_name == null || $plan_name == "")
        return false;       
	
    //retrieve fields from plan
    $q="SELECT * FROM $this->plan_table WHERE pname='$plan_name'";

    $result=$this->myDB->query($q);
    
    $fields=array();

    if (odbc_fetch_row($result)) {
	// 20071204 - Round all numeric fields
	for ($i = 1; $i <= odbc_num_fields($result); $i++) {
	    if ((strtolower(odbc_field_type($result, $i)) == "numeric" || strtolower(odbc_field_type($result, $i)) == "integer") && (odbc_result($result, $i) != NULL || strlen(odbc_result($result, $i)) > 0)) {
		$fields[strtolower(odbc_field_name($result, $i))] = round(odbc_result($result, $i));
	    } else {
		$fields[strtolower(odbc_field_name($result, $i))] = odbc_result($result, $i);
	    }
	}
    }
    else {
	    echo 'Warning! No plan selected of that item. ';
	     return false;
    }

    $q="SELECT * FROM $this->usr_table WHERE name = '$username'";
    $result=$this->myDB->query($q);

    // 20071009 - Clear plan edate if user edate is NULL
    // 20070712 - Clear edate content if eminutes is not NULL
    if (((strlen($fields["edate"]) > 0 || $fields["edate"] != NULL) && (strlen($fields["eminutes"]) > 0 || $fields["eminutes"] != NULL)) || odbc_result($result, "edate") == NULL || odbc_result($result, "edate") == "") {
	$fields["edate"] = NULL;
    }

    // 20071203 - Round up values to prevent special SQL error
    // 20070918 - Separate case for bwquota and bwquotaul
    // 20070712 - Remove eminutes
    $correct_fields = array("timeleft", "logins", "pagenum");
    foreach ($correct_fields as $value)
    {
      if ( (strlen(odbc_result($result, $value)) > 0 || odbc_result($result, $value) != null) && (strlen($fields[$value]) > 0 || $fields[$value] != null) )
        $fields[$value] = round(odbc_result($result, $value) + ($fields[$value] * $quantity));
      else if ( (odbc_result($result, $value) == null || odbc_result($result, $value) == "") && (strlen($fields[$value]) > 0 || $fields[$value] != null) )
        $fields[$value] = NULL;
    }

    // 20071203 - Round up values to prevent special SQL error
    $correct_fields = array("bwquota", "bwquotaul");
    foreach ($correct_fields as $value) {
	if (strlen($fields[$value]) > 0 || $fields[$value] != NULL) {
	    $fields[$value] = round($fields[$value] * $quantity);
	} else {
	    $fields[$value] = NULL;
	}
    }

    // 20071203 - Round up values to prevent special SQL error
    // 20070712 - Update edate and eminutes according to the active option set in the plan
    $eMinutes = round($fields["eminutes"]);
    $startMod = round($fields["startmod"]);
    $eDate = odbc_result($result, "edate");
    $mac = odbc_result($result, "reserved1");
    if ($eDate == NULL) {
	$eDate = '';
    }
    if ($mac == NULL) {
	$mac = '';
    }
    //echo "<script>alert('mac: ".$mac."')</script>";
    //echo "<script>alert('old: ".$eDate."')</script>";

    // 20071203 - Round up values to prevent special SQL error
    // 20071009 - Adjust plan edate if user edate is not NULL, else clear plan eminutes
    if (strlen($eDate) > 0 && $eDate != "" && $eDate != NULL) {
	if ((strlen($startMod) > 0 || $startMod != NULL) && $startMod == 0 && (strlen($eMinutes) > 0 || $eMinutes != NULL) && $eMinutes > 0) {
	    $newEdate = '';
	    $myObj = new COM('FSAUTH.Authserv') or die('transaction.php FSAUTH.Authserv Object cannot be created!');
	    $objResult = $myObj->UpdateEdate($mac, $eDate, $eMinutes, $newEdate);

	    // Update edate and remove eminutes in user table
	    $fields["edate"] = $newEdate;
	    $fields["eminutes"] = NULL;
	    $myObj = NULL;
	} else if ((strlen($startMod) > 0 || $startMod != NULL) && $startMod > 0 && (strlen($eMinutes) > 0 || $eMinutes != NULL) && $eMinutes > 0) {
	    $fields["edate"] = $eDate;
	    $correct_fields = array("eminutes");
	    foreach ($correct_fields as $value) {
		if ((strlen(odbc_result($result, $value)) > 0 || odbc_result($result, $value) != NULL) && (strlen($fields[$value]) > 0 || $fields[$value] != NULL)) {
		    $fields[$value] = round(odbc_result($result, $value) + ($fields[$value] * $quantity));
		} else if ((odbc_result($result, $value) == NULL || odbc_result($result, $value) == "") && (strlen($fields[$value]) > 0 || $fields[$value] != NULL)) {
		    $fields[$value] = round($fields[$value] * $quantity);
		}
	    }
	}
    } else {
	$fields["eminutes"] = NULL;
    }
    //echo "<script>alert('new: ".$fields["edate"]."')</script>";

    //$fname_offline = array("bwcount", "bwcountul", "ipmap", "resetopt");
    $fname_exclude = array("pname", "bwcount", "bwcountul", "ipmap", "resetopt");
    
    $field_update = array();
    //$field_offline = array();
    
    //foreach ($fname_offline as $fname) {
	//  $field_offline[$fname] = $fields[$fname];
	//  $fields[$fname] = "unused";
    //}
    
    // 20071203 - Round up values to prevent special SQL error
    // 20071003 - Check not to update bwquota values for offline update
    $planBwCountDl = $fields["bwcount"];
    $planBwCountUl = $fields["bwcountul"];
    $userBwCountDl = round(odbc_result($result, "bwcount"));
    $userBwCountUl = round(odbc_result($result, "bwcountul"));
    $userBwQuotaDl = round(odbc_result($result, "bwquota"));
    $userBwQuotaUl = round(odbc_result($result, "bwquotaul"));
    $userMac = odbc_result($result, "reserved1");
    if ($userMac == "") {
	if ($planBwCountDl != 2 || ($planBwCountDl == 2 && $userBwCountDl != 2)) {
	    $fields["bwquota"] = "unused";
	}
	if ($planBwCountUl != 2 || ($planBwCountUl == 2 && $planBwCountUl != 2)) {
	    $fields["bwquotaul"] = "unused";
	}
    }
    
    foreach ($fname_exclude as $fname) {
	  $fields[$fname] = "unused";
    }

    foreach ($fields as $key => $value) {
	// 20071204 - Log for debug use only
	if (strcmp("$value", "unused") != 0) {
	    $field_update[$key] = $value;
	    //$this->writeLog("..\\log\\txn.log", $key."->".$value."\r\n");
	}
    }
    
    $this->myDB->update($this->usr_table, $field_update, "WHERE name = '$username'");
    $this->myDB->query("UPDATE $this->usr_table SET bwquota = null WHERE name = '$username' AND NOT(bwcount = 2)");
    $this->myDB->query("UPDATE $this->usr_table SET bwquotaul = null WHERE name = '$username' AND NOT(bwcountul = 2)");
    // 20071004 - Save the unchanged quota value to reserved field for later restorage during online udpate
    if ($userMac != "") {
	if ($planBwCountDl != 2 && $userBwCountDl == 2) {
	    $this->myDB->query("UPDATE $this->usr_table SET reserved13 = $userBwQuotaDl WHERE name = '$username' AND bwcount = 2");
	}
	if ($planBwCountUl != 2 && $userBwCountUl == 2) {
	    $this->myDB->query("UPDATE $this->usr_table SET reserved14 = $userBwQuotaUl WHERE name = '$username' AND bwcount = 2");
	}
    }

    // 20071003 - Reset accumbw value only along with plan update
    // 20070924 - Check config parameters instead of DB
    // 20070918 - Reset accumbw_dl and accumbw_ul if required
    $settingObj = new COM('FSCONFIG.Cfgmgr') or die('transaction.php FSCONFIG.Cfgmgr Object cannot be created!');
    $flagResetBwCount = $settingObj->getKey('reset_bw_count_upon_purchase', 'cart');
    if ($flagResetBwCount == "1") {
	if ($planBwCountDl == 2) {
	    $this->myDB->query("UPDATE $this->usr_table SET accumbw = null WHERE name = $username AND bwcount = 2");
	}
	if ($planBwCountUl == 2) {
	    $this->myDB->query("UPDATE $this->usr_table SET accumbwul = null WHERE name = $username AND bwcountul = 2");
	}
    }
    $settingObj = NULL;
 
    $this->myDB->close();

    return true;
  }


  function update_transaction($invoice, $arr_fields)
  { 
    $this->myDB->update($this->transaction_table, $arr_fields, "WHERE invoice = $invoice");
    $this->myDB->close();

    return true;
  }


  function insert_transaction($username, $arr_fields)
  {
    if ($username == null || $username == "")
      return -1;
    
    $zerocount = false;
 
    //prevent invoice == null 
    $q="SELECT count(*) FROM $this->transaction_table";
    $result = $this->myDB->query($q);
    if(round(odbc_result($result, 1)) <= 0)
    {
      $zerocount = true;
      $this->myDB->close();
      $q="INSERT INTO $this->transaction_table (invoice) VALUES (0)";
      $this->myDB->query($q);
    }
    $this->myDB->close();

    //$now=date("YmdHisZ");
    $now=time();
    
    $fields_name = "INVOICE, USERNAME, ORDER_DATE";
    //$fields_value = "$invoice_no, '$now'";
    $fields_value = "SELECT max(invoice)+1, '$username', '$now'";

    foreach ($arr_fields as $key => $value) {
      if (strtoupper($key) != "INVOICE" || strtoupper($key) != "USERNAME" || strtoupper($key) != "ORDER_DATE")
      {
        $fields_name .= ", ".$key;
        if (strlen($value) > 0 || $value != NULL)
            $fields_value .= ", '$value'";
        else
            $fields_value .= ", NULL";
      }
    }

    if (isset($arr_fields['planname']) && $arr_fields['planname'] != "" && $arr_fields['planname'] != null) {
      $q="SELECT * FROM $this->plan_table WHERE pname='".$arr_fields['planname']."'";
      $result=$this->myDB->query($q);
      if (odbc_fetch_row($result)) {
	    $fields["timeleft"] = round(odbc_result($result, "timeleft"));
	    $fields["btul"] = round(odbc_result($result, "btul"));
	    $fields["btdl"] = round(odbc_result($result, "btdl"));
	    $fields["bwquota"] = odbc_result($result, "bwquota");
	    $fields["bwcount"] = round(odbc_result($result, "bwcount"));
	    $fields["bwquotaul"] = odbc_result($result, "bwquotaul");
	    $fields["bwcountul"] = round(odbc_result($result, "bwcountul"));
	    $fields["sdate"] = odbc_result($result, "sdate");
	    $fields["edate"] = odbc_result($result, "edate");
	    $fields["logins"] = round(odbc_result($result, "logins"));
	    $fields["eminutes"] = round(odbc_result($result, "eminutes"));
	    $fields["startmod"] = round(odbc_result($result, "startmod"));
	    $fields["auto_del"] = round(odbc_result($result, "auto_del"));
	    $fields["bwrmethod"] = odbc_result($result, "bwrmethod");
	    $fields["bwrperiod"] = round(odbc_result($result, "bwrperiod"));
	    //$fields["lastrbw"] = odbc_result($result, "lastrbw");
	    $fields["bwrdate"] = round(odbc_result($result, "bwrdate"));
	    $fields["pagenum"] = round(odbc_result($result, "pagenum"));
        
        foreach ($fields as $key => $value) {
          $fields_name .= ", ".$key;
          if (strlen($value) > 0 || $value != NULL)
            $fields_value .= ", '$value'";
          else
            $fields_value .= ", NULL";
        }
      }

      $this->myDB->close();
    }

    $fields_value .= " FROM $this->transaction_table";

    $q = "INSERT INTO $this->transaction_table ($fields_name) $fields_value";
    $this->myDB->query($q);
    $this->myDB->close();

    if ($zerocount == true) {
      $q = "DELETE FROM $this->transaction_table WHERE invoice=0";
      $this->myDB->query($q);
      $this->myDB->close();
    }

    $q="SELECT max(INVOICE) FROM $this->transaction_table WHERE username = '$username'";
    $result = $this->myDB->query($q);
    if (odbc_fetch_row($result))
      $invoice_no = round(odbc_result($result, 1));
    else
      return -1;
    //echo $invoice_no;
    $this->myDB->close();
   
    return $invoice_no;
  }

  function live_update($username)
  {
    $updated = false;    

    // 20070925 - Remove bwrmethod
    // 20070921 - Add bwrmethod
    $q="SELECT reserved1, timeleft, reserved12, bwcount, bwcountul, bwquota, bwquotaul, accumbw, accumbwul, btul, btdl, resetopt FROM $this->usr_table WHERE name = '$username'";

    $result=$this->myDB->query($q);
    if(!odbc_fetch_row($result))
      return false;
    
    $mac = odbc_result($result, "reserved1");
    $resetopt = ( odbc_result($result, "resetopt")==""? 0 : round(odbc_result($result, "resetopt")) );
    
    $tleft = ( odbc_result($result, "timeleft")==""? 0 : round(odbc_result($result, "timeleft")) );
    $tleft -= ( odbc_result($result, "reserved12")==""? 0 : round(odbc_result($result, "reserved12")) );
    
    $bwcount_ul = odbc_result($result, "bwcountul");
    $bwcount_dl = odbc_result($result, "bwcount");
    $bwquota_ul = ( odbc_result($result, "bwquotaul")==""? 0 : round(odbc_result($result, "bwquotaul")) );
    $bwquota_dl = ( odbc_result($result, "bwquota")==""? 0 : round(odbc_result($result, "bwquota")) );
    $bwaccum_ul = ( odbc_result($result, "accumbwul")? 0 : round(odbc_result($result, "accumbwul")) );
    $bwaccum_dl = ( odbc_result($result, "accumbw")? 0 : round(odbc_result($result, "accumbw")) );
    $bwquota_ul -= $bwaccum_ul;
    $bwquota_dl -= $bwaccum_dl;

    $throttle_ul = ( odbc_result($result, "btul")==""? -1 : round(odbc_result($result, "btul")) );
	$throttle_dl = ( odbc_result($result, "btdl")==""? -1 : round(odbc_result($result, "btdl")) );
    $this->myDB->close();
    
    // 20070925 - Modify condition and input parameters to perform data transfer quota update
    if($mac != "") {
	$myObj = new COM('FSAUTH.Authserv') or die('transaction.php FSAUTH.Authserv Object cannot be created!');

	// 20071004 - Remove quota conditions
	if ($bwcount_ul == 2 || $bwcount_dl == 2) {

	    // 20070925 - Get reset counter flag from config
	    $settingObj = new COM('FSCONFIG.Cfgmgr') or die('transaction.php FSCONFIG.Cfgmgr Object cannot be created!');
	    $flagResetBwCount = $settingObj->getKey('reset_bw_count_upon_purchase', 'cart');
	    $objresult = $myObj->UpdateBWcount($mac, $flagResetBwCount);
	    $settingObj = NULL;

	    $updated = true;
	}
	if ($resetopt == 1) {
	    if ( $tleft>0 ) {
		$objresult = $myObj->UpdateTimeleft($mac, $tleft);
		$updated = true;
	    }

	    if ( $tleft>0 || ($bwcount_ul==2 && $bwquota_ul>0) || ($bwcount_dl==2 && $bwquota_dl>0) )
		$objrsult = $myObj->UpdateThrottle($mac, $throttle_ul, $throttle_dl);
	}
    }
    
    $myObj = null;

    return $updated;
  }

  function isexist_transaction($field_name, $field_value)
  {
    $exist = false;
    
    if ( strtolower($field_name) == "invoice" )
      $q="SELECT * FROM $this->transaction_table WHERE ".$field_name." = $field_value";
    else
      $q="SELECT * FROM $this->transaction_table WHERE ".$field_name." = '".$field_value."'";
    
    $result = $this->myDB->query($q);
    
    if (odbc_fetch_row($result))
      $exist = true;
    
    $this->myDB->close();
    return $exist;
  }

  function writeLog($file, $log)
  {
    $fh = fopen($file, "a");
    
    if ($fh) {
      flock($fh, LOCK_EX);
      fwrite($fh, $log);
      flock($fh, LOCK_UN);
      fclose($fh);
    }
  }

    // 20071119 - Using number_format to handle decimal price value comparison
    // 20070807 - Check if the price matches the plan description in config file
    function ValidateCart($description, $price) {
	$cnt = 0;
	$result = -1;
	$settingObj = new COM('FSCONFIG.Cfgmgr') or die('transaction.php FSCONFIG.Cfgmgr Object cannot be created!');

	$num = $settingObj->getKey('max_slot_open', 'cart');
	for ($cnt = 0; $cnt < $num; $cnt++) {
	    $tmp = $settingObj->getKey('description'.$cnt, 'cart');
	    if (strcmp($tmp, $description) == 0) {
		$result = -2;
		$tmp = $settingObj->getKey('price'.$cnt, 'cart');
		if (number_format($tmp) == number_format($price)) {
		    $result = 0;
		}
		break;
	    }
	}

	$settingObj = NULL;
	return $result;
    }
}
?>
